package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.LayoutManager;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.activation.ActivateFailedException;
import java.util.Timer;
import java.util.TimerTask;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

public class ExperimentDialog extends JDialog implements ActionListener{

	public static boolean imageDownloaded=false;
	public static BufferedImage samImage;
	MainFrame10 owner;
	ResourceWaiterButton unprimedCountReady;
	JTextPane ucInstructions;
	JScrollPane instructionScroll;
	JLabel picture;
	String unprimedCountText;
	String fileHeader;
	String soundFileName;
	Timer uctimer = new Timer();
	Clip clip = null;
	BufferedImage image1;
	

	public ExperimentDialog(MainFrame10 owner, String title, String instructionText, String fileHeader, String soundFileName) {
		super();
		
		synchronized (ExperimentDialog.class) {
			while(!(imageDownloaded)) {
				try {
					ExperimentDialog.class.wait();
				} catch (InterruptedException e) {
				}
			}			
		}
		
		this.owner=owner;
		unprimedCountText=instructionText;
		this.fileHeader=fileHeader;
		this.soundFileName=soundFileName;
		setModal(true);
		LayoutManager uclm = new BorderLayout();
		getContentPane().setLayout(uclm);
		ucInstructions = new JTextPane();
		ucInstructions.setText(instructionText);
		ucInstructions.setEditable(false);
		ucInstructions.setBackground(Color.LIGHT_GRAY);


		ucInstructions.setFont(new Font("serif",Font.BOLD,15));

		SimpleAttributeSet attribs = new SimpleAttributeSet(); 
		StyleConstants.setAlignment(attribs , StyleConstants.ALIGN_JUSTIFIED);  
		StyleConstants.setFontSize(attribs, 17);
		ucInstructions.setSelectionStart(0);
		ucInstructions.setSelectionEnd(ucInstructions.getText().length());
		//ucInstructions.setParagraphAttributes(attribs,true);


		//unprimedCountReady = new JButton("I'm Ready");
		

		unprimedCountReady = new ResourceWaiterButton("I'm Ready");
		try {
			clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+soundFileName));
		} catch (MalformedURLException e1) {
			e1.printStackTrace();
		}
		
		unprimedCountReady.setResource(clip);
		unprimedCountReady.addActionListener(this);
		instructionScroll = new JScrollPane(ucInstructions);
		instructionScroll.setPreferredSize(new Dimension(300, 200));
		ucInstructions.setCaretPosition(0);

		picture = new JLabel(new ImageIcon (samImage));
		getContentPane().add(picture,BorderLayout.NORTH);
		getContentPane().add(instructionScroll,BorderLayout.CENTER);
		getContentPane().add(unprimedCountReady, BorderLayout.SOUTH);

		ucInstructions.setFocusable(false);
		pack();
		MainFrame10.centerWindow(this);
		setResizable(false);
	}

	public static void downloadSAM() {
		try {
			BufferedImage result =ImageIO.read(new URL(MainFrame10.url_addr + "/images/SAM.png"));
			imageDownloaded = true;
			synchronized (ExperimentDialog.class) {
				ExperimentDialog.class.notifyAll();
			}
			samImage = result;
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==unprimedCountReady) {
			unprimedCountReady.setEnabled(false);
			clip.play();
			double length = clip.getLength();

			uctimer.schedule(new TimerTask() {
				@Override
				public void run() {
					ucDialogClose();
				}
			}, (long)(length*1000));
		}	
	}

	void ucDialogClose() {
		setVisible(false);
		unprimedCountReady.setEnabled(true);
	}
}
