package gui;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import javax.swing.JToggleButton;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

public class  FormDialogSubtitles extends JDialog implements ActionListener {
	int cols = 9;
	int counter = 0;
	public static boolean imagesADownloaded = false;
	public static boolean imagesVDownloaded = false;	
	static Vector<BufferedImage> imagesA;
	static Vector<BufferedImage> imagesV;
	Vector<JToggleButton> togglesA = new Vector<JToggleButton>();
	Vector<JToggleButton> togglesV = new Vector<JToggleButton>();
	Vector<JCheckBox> checkBoxes = new Vector<JCheckBox>();
	Vector<String> sounds = new Vector<String>();
	Vector<String>  srtFiles; 
	Vector<String> srtTimes;
	JPanel itemsPanel;
	ResourceWaiterButton nextButton;
	JButton finishButton;
	ResourceWaiterButton startButton;
	JButton previousButton;
	JButton playAgainButton;
	JLabel arousalLabel;
	String fileName;
	File outputFolder;
	Timer uctimer = new Timer();
	int start;
	int finish;
	Vector<String>  outStringAll = new Vector<String> ();
	Vector<Integer>  lengthAll = new Vector<Integer> ();
	Vector<Integer>  startAll = new Vector<Integer> ();
	Vector<Integer>  sizeAll = new Vector<Integer> ();
	JTextPane srtPane = new JTextPane();
	JTextArea titleArea1 = new JTextArea();
	JTextArea titleArea2 = new JTextArea();
	String toBeWritten = " ";
	int timeToWait = 1000; // in mili seconds
	int typeExp;
	String attendantNameString;
	String clipStartTime;
	String clipEndTime;
	String clipRateStartTime;
	String clipRateEndTime;
	boolean rateStarted=false;
	JButton toActivate;
	public void setAttendantNameString(String attendantNameString) {
		this.attendantNameString = attendantNameString;
	}


	String lineEnd = "\r\n";
	BufferedImage  image1;
	URL oracle;
	Clip clip = null;




	@SuppressWarnings("unchecked")
	public FormDialogSubtitles(Window owner, File outputFolder, String fileName, Vector<String>  sounds, Vector<String>  srtFiles, Vector<String> srtTimes, int typeExp, String attendantNameString, JButton toActivate){
		super(owner,"Rating Emotion");
		this.toActivate = toActivate;
		synchronized (FormDialogSubtitles.class) {
			while(!(imagesADownloaded&&imagesVDownloaded)) {
				try {
					FormDialogSubtitles.class.wait();
				} catch (InterruptedException e) {
				}
			}			
		}

		this.fileName=fileName;
		this.outputFolder = outputFolder;
		setModal(true);

		this.sounds=(Vector<String>) sounds.clone();
		this.srtFiles=(Vector<String>) srtFiles.clone();
		this.srtTimes=(Vector<String>) srtTimes.clone();
		this.typeExp = typeExp;
		this.attendantNameString = attendantNameString;
		itemsPanel = new JPanel();

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				JOptionPane.showMessageDialog(null, "You're closing this window, but this section is not finished yet,\nplease complete it to proceed with the rest of the experiment.\nYou can continue from where you left by clicking on the same button that\nstarted it, unless you leave the experiment webpage on your browser.\n If you also leave the experiment webpage, you can continue using the \n 'continue' button next time you enter the webpage. \n Please don't take long breaks! Otherwise, the data will not be valid.", 
						"Caution!", JOptionPane.INFORMATION_MESSAGE);
			}
		});

		GridLayout itemslayout = new GridLayout((int)Math.ceil((double) 9/cols*2),cols);
		itemsPanel.setLayout(itemslayout);

		for(Integer i=0; i<9; i++) {

			//			try {
			//				oracle = new URL(MainFrame10.url_addr + "/images/SAMV"+Integer.toString(i+1)+".png");
			//				try {
			//					image1 = ImageIO.read(oracle);
			//				} catch (IOException e1) {
			//					// TODO Auto-generated catch block
			//					e1.printStackTrace();
			//				}
			//			} catch (MalformedURLException e2) {
			//				// TODO Auto-generated catch block
			//				e2.printStackTrace();
			//			}
			image1 = imagesV.get(i);

			JToggleButton newJToggleBut = new JToggleButton(new ImageIcon (image1));
			newJToggleBut.setBackground(new Color(184, 207, 229));
			newJToggleBut.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
			newJToggleBut.addActionListener(this);
			newJToggleBut.setEnabled(false);
			itemsPanel.add(newJToggleBut);
			togglesV.add(newJToggleBut);

		}


		for(Integer i=0; i<9; i++) {
			//			try {
			//				oracle = new URL(MainFrame10.url_addr + "/images/SAMA"+Integer.toString(i+1)+".png");
			//				try {
			//					image1 = ImageIO.read(oracle);
			//				} catch (IOException e1) {
			//					// TODO Auto-generated catch block
			//					e1.printStackTrace();
			//				}
			//			} catch (MalformedURLException e2) {
			//				// TODO Auto-generated catch block
			//				e2.printStackTrace();
			//			}

			image1 = imagesA.get(i);

			JToggleButton newJToggleBut = new JToggleButton(new ImageIcon (image1));
			newJToggleBut.setBackground(new Color(184, 207, 229));
			newJToggleBut.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
			newJToggleBut.addActionListener(this);
			newJToggleBut.setEnabled(false);
			itemsPanel.add(newJToggleBut);
			togglesA.add(newJToggleBut);

		}

		itemsPanel.setMinimumSize(new Dimension(itemsPanel.getWidth(), 400));




		nextButton = new ResourceWaiterButton("Next");
		nextButton.addActionListener(this);
		nextButton.setEnabled(false);

		previousButton = new JButton("Previous");
		previousButton.addActionListener(this);
		previousButton.setEnabled(false);

		startButton = new ResourceWaiterButton("Start");
		startButton.addActionListener(this);
		// startButton.setEnabled(true);

		playAgainButton = new JButton("Play Again");
		playAgainButton.addActionListener(this);
		playAgainButton.setEnabled(false);

		finishButton = new JButton("Finish");
		finishButton.addActionListener(this);
		finishButton.setEnabled(false);

		Vector<String> cacheList = new Vector<String>();
		for (int i = 0; i < sounds.size(); i++){
			cacheList.add(MainFrame10.url_addr+"/"+sounds.elementAt(i));
		}
		Clip.preCache(cacheList);

		if(counter != sounds.size()){
			try {
				clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			}
		}
		if (typeExp == 1 || typeExp == 2){
			startButton.setResource(clip);
		}


		// BorderLayout layout = new BorderLayout();
		// getContentPane().setLayout(layout);

		GridBagLayout gblayout = new GridBagLayout();
		getContentPane().setLayout(gblayout);


		// arousalLabel = new JLabel(new ImageIcon("SAMA.png"));

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 0.0;
		c.gridwidth = 5;
		getContentPane().add(itemsPanel,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 1;
		c.weightx = 0.5;
		getContentPane().add(startButton,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 1;
		c.gridy = 1;
		c.gridwidth = 1;
		c.weightx = 0.5;
		getContentPane().add(previousButton,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 2;
		c.gridy = 1;
		c.weightx = 0.5;
		c.gridwidth = 1;
		getContentPane().add(nextButton,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 3;
		c.gridy = 1;
		c.weightx = 0.5;
		c.gridwidth = 1;
		getContentPane().add(playAgainButton,c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 4;
		c.gridy = 1;
		c.weightx = 0.5;
		c.gridwidth = 1;
		getContentPane().add(finishButton,c);
		c.fill = GridBagConstraints.HORIZONTAL;

		Dimension minimumSizeTextPane = new Dimension(getContentPane().getWidth(), 300);
		srtPane.setMinimumSize(minimumSizeTextPane);

		c.gridx = 0;
		c.gridy = 2;
		c.weightx = 0.5;
		c.gridwidth = 5;
		getContentPane().add(srtPane,c);


		String openingText0 = "READ SUBTITLES HERE (NO SOUND, JUST SUBTITLES) !!";
		String openingText1 = "NO SUBTITLES, JUST SOUND!!";
		String openingText2 = "READ SUBTITLES HERE (THERE IS ALSO SOUND) !!";
		if (typeExp == 0 ){
			WritePane(openingText0);
		}
		else if (typeExp == 1 ){
			WritePane(openingText1);
		}else if (typeExp == 1 ){
			WritePane(openingText2);
		}

		srtPane.setBackground(Color.black);
		srtPane.setEditable(false);
		//	    srtPane.setMinimumSize(new Dimension(getContentPane().getWidth(), 300 ));




		//getContentPane().add(nextButton,BorderLayout.EAST);
		//getContentPane().add(startButton,BorderLayout.WEST);
		//getContentPane().add(itemsPanel,BorderLayout.NORTH);
		// getContentPane().add(arousalLabel,BorderLayout.SOUTH);



		pack();
		setLocationRelativeTo(owner);
		this.setResizable(false);

		//MainFrame10.centerWindow(this);



	}

	public static void downloadImagesA() {
		Vector<BufferedImage> result = new Vector<BufferedImage>();
		for(Integer i=0; i<9; i++) {
			try {
				URL oracle = new URL(MainFrame10.url_addr + "/images/SAMA"+Integer.toString(i+1)+".png");
				BufferedImage image1 = ImageIO.read(oracle);
				result.add(image1);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		imagesADownloaded=true;
		synchronized (FormDialogSubtitles.class) {
			FormDialogSubtitles.class.notifyAll();
		}
		imagesA = result;
	}

	public static void downloadImagesV() {
		Vector<BufferedImage> result = new Vector<BufferedImage>();
		for(Integer i=0; i<9; i++) {
			try {
				URL oracle = new URL(MainFrame10.url_addr + "/images/SAMV"+Integer.toString(i+1)+".png");
				BufferedImage image1 = ImageIO.read(oracle);
				result.add(image1);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		imagesVDownloaded=true;
		synchronized (FormDialogSubtitles.class) {
			FormDialogSubtitles.class.notifyAll();
		}
		imagesV = result;
	}

	@Override
	public Dimension getPreferredSize() {
		// TODO Auto-generated method stub
		return super.getPreferredSize();
	}

	public void actionPerformed(ActionEvent e) {

		if(e.getSource()==startButton){
			try
			{
				String writeSoundsinOrder = "";
				for (int i = 0; i < sounds.size(); i++){
					writeSoundsinOrder = writeSoundsinOrder + sounds.elementAt(i)+lineEnd;
				}
				boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_sounds.dat", writeSoundsinOrder );	
				if(!success){
					MainFrame10.WriteSuccessError();
				}

			}
			catch (Exception ex)
			{
				ex.printStackTrace();
				System.err.println ("Error writing to file");
			}

			
			JobOfStart();


		}

		else if(e.getSource()==finishButton){
			
			boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", " RateStarts "+clipRateStartTime+" RateEnds "+clipRateEndTime+lineEnd);
			if(!success){
				MainFrame10.WriteSuccessError();
			}
			WriteRatings();
			if(toActivate!=null) toActivate.setEnabled(true);

			this.setVisible(false);

		}


		else if(e.getSource()==nextButton){
			
			rateStarted=false;
			boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", " RateStarts "+clipRateStartTime+" RateEnds "+clipRateEndTime+lineEnd);
			if(!success){
				MainFrame10.WriteSuccessError();
			}
			WriteRatings(); 
			JobOfNextWoWrite();

		}

		else if(e.getSource()==previousButton){
			
			boolean success0=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", " RateStarts Previous RateEnds Button "+lineEnd);
			if(!success0){
				MainFrame10.WriteSuccessError();
			}
			
			previousButton.setEnabled(false);
			nextButton.setEnabled(false);
			counter = counter - 2 ;
			//seliz 1		

			try {
				boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_previous_log.dat", sounds.elementAt(counter) + " " + Integer.toString(counter)+lineEnd);
				if(!success){
					MainFrame10.WriteSuccessError();
				}
			} 			
			catch (Exception ex)
			{
				System.err.println ("Error writing to file");
			}
			//seliz 2
			if(counter == 0){
				for(JToggleButton buttonV: togglesV) {
					buttonV.setEnabled(false);
					buttonV.setSelected(false);
					buttonV.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				for(JToggleButton buttonA: togglesA) {
					buttonA.setEnabled(false);
					buttonA.setSelected(false);
					buttonA.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				
				if(counter != sounds.size()){
				try {
					clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
				} catch (MalformedURLException e1) {
					e1.printStackTrace();
				}
				}
				
				if (typeExp == 1 || typeExp == 2){
					startButton.setResource(clip);
				}

				JobOfStart();
			}
			else {
				for(JToggleButton buttonV: togglesV) {
					buttonV.setEnabled(false);
					buttonV.setSelected(false);
					buttonV.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				for(JToggleButton buttonA: togglesA) {
					buttonA.setEnabled(false);
					buttonA.setSelected(false);
					buttonA.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}

				if(counter != sounds.size()){
					try {
						clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
					} catch (MalformedURLException e1) {
						e1.printStackTrace();
					}
				}
				if (typeExp == 1 || typeExp == 2){
					nextButton.setResource(clip);
				}

				JobOfNextWoWrite();
			}

		}

		else if(e.getSource()==playAgainButton){
			
			boolean success0=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", " RateStarts PlayAgain RateEnds Button "+lineEnd);
			if(!success0){
				MainFrame10.WriteSuccessError();
			}
			nextButton.setEnabled(false);
			counter = counter -1;
			// seliz 1			
			try {
				boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_playAgain_log.dat", sounds.elementAt(counter) + " " + Integer.toString(counter)+lineEnd);
				if(!success){
					MainFrame10.WriteSuccessError();
				}
			} 			
			catch (Exception ex)
			{
				System.err.println ("Error writing to file");
			}
			// seliz 2

			if(counter == 0){
				for(JToggleButton buttonV: togglesV) {
					buttonV.setEnabled(false);
					buttonV.setSelected(false);
					buttonV.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				for(JToggleButton buttonA: togglesA) {
					buttonA.setEnabled(false);
					buttonA.setSelected(false);
					buttonA.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				if(counter != sounds.size()){
					try {
						clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
					} catch (MalformedURLException e1) {
						e1.printStackTrace();
					}
				}
				if (typeExp == 1 || typeExp == 2){
					startButton.setResource(clip);
				}
				JobOfStart();
			}
			else {
				for(JToggleButton buttonV: togglesV) {
					buttonV.setEnabled(false);
					buttonV.setSelected(false);
					buttonV.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
				for(JToggleButton buttonA: togglesA) {
					buttonA.setEnabled(false);
					buttonA.setSelected(false);
					buttonA.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}

				if(counter != sounds.size()){
					try {
						clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
					} catch (MalformedURLException e1) {
						e1.printStackTrace();
					}
				}
				if (typeExp == 1 || typeExp == 2){
					nextButton.setResource(clip);
				}

				JobOfNextWoWrite();
			}
		}

		else if(togglesA.contains(e.getSource())){
			if(!rateStarted){
				clipRateStartTime=CurrentTime();
				rateStarted=true;
			}
			clipRateEndTime = CurrentTime();
			JToggleButton currentButton = (JToggleButton) e.getSource();
			currentButton.setSelected(true);
			currentButton.setBorder(BorderFactory.createLineBorder(Color.red, 4));
			for(JToggleButton button: togglesA) {
				if(button != currentButton){
					button.setSelected(false);
					button.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
			}

			int bothselected = 0;
			for(JToggleButton button: togglesV){
				if(button.isSelected()){
					bothselected = 1;
				}
			}
			if(bothselected == 1){
				if(counter==sounds.size()){
					finishButton.setEnabled(true);
				}
				else{
					nextButton.setEnabled(true);
				}
			}
		}

		else if(togglesV.contains(e.getSource())){
			if(!rateStarted){
				clipRateStartTime=CurrentTime();
				rateStarted=true;
			}
			clipRateEndTime = CurrentTime();
			JToggleButton currentButton = (JToggleButton) e.getSource();
			currentButton.setSelected(true);
			currentButton.setBorder(BorderFactory.createLineBorder(Color.red, 4));
			for(JToggleButton button: togglesV) {
				if(button != currentButton){
					button.setSelected(false);
					button.setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
				}
			}

			int bothselected = 0;
			for(JToggleButton button: togglesA){
				if(button.isSelected()){
					bothselected = 1;
				}
			}
			if(bothselected == 1){
				
				if(counter==sounds.size()){
					finishButton.setEnabled(true);
				}
				else{
					nextButton.setEnabled(true);
				}
			}

		}



	}


	AudioFormat 			audioFormat;
	AudioInputStream           audioInputStream;
	SourceDataLine                sourceDataLine;
	boolean                stopPlayback = false;

	public  double play(File soundFile)
	{
		try{
			audioInputStream = AudioSystem.getAudioInputStream(soundFile); //get audio stream
			audioFormat      = audioInputStream.getFormat(); //get format of stream

			if(audioFormat.getEncoding() != AudioFormat.Encoding.PCM_SIGNED) //check that stream is proper format
			{
				audioInputStream = AudioSystem.getAudioInputStream(AudioFormat.Encoding.PCM_SIGNED,audioInputStream);
				audioFormat       = audioInputStream.getFormat(); //fix improper wave format
			}

			DataLine.Info dataLineInfo = new DataLine.Info(SourceDataLine.class,audioFormat); //request a data line (not open)

			sourceDataLine = (SourceDataLine)AudioSystem.getLine(dataLineInfo); //inform line of data type
			stopPlayback   = false; //allow playback
			//              if (typeExp == 1 || typeExp == 2){
			//            	  new Play_Audio().start(); //play thread
			//              }
		}
		catch (Exception error)
		{
			JOptionPane.showMessageDialog(null, "The audio file cannot be opened!", 
					"Error!", JOptionPane.INFORMATION_MESSAGE);

		}
		return (double)(soundFile.length() / (audioFormat.getFrameRate() * audioFormat.getChannels() * audioFormat.getSampleSizeInBits() / 8));
	}

	/**
	 *Play_Audio Class
	 */
	private class Play_Audio extends Thread
	{
		byte buffer[] = new byte[10000]; //10KB buffer, will not be too large for any system

		/**
		 *Thread event which handles audio playback
		 */
		public void run()
		{
			try{
				sourceDataLine.open(audioFormat); //open the line
				sourceDataLine.start(); //prepare line for data transfer

				int continue_play;
				while((continue_play = audioInputStream.read(buffer,0,buffer.length)) != -1 && stopPlayback == false)
				{
					if(continue_play > 0) //data still left to write
					{
						sourceDataLine.write(buffer, 0, continue_play); //write data to the line
					}
				}
				sourceDataLine.drain(); //clear buffer
				sourceDataLine.close(); //close line
			}
			catch(Exception e)
			{
				JOptionPane.showMessageDialog(null, "The audio file cannot be opened!", 
						"Error!", JOptionPane.INFORMATION_MESSAGE);

			}
		}
	}

	String strLine;

	public String ReadFile(String fileName, Integer lineNumber, boolean digitOrChar, boolean digitTime)
	{
		try{
			// Open the file that is the first 
			// command line parameter
			FileInputStream fstream = new FileInputStream(fileName);
			// Get the object of DataInputStream
			URL oracle = new URL(MainFrame10.url_addr + "/" + fileName);
			BufferedReader br = TextFile.getTextFile(oracle).getBufferedReader();//new BufferedReader(new InputStreamReader(oracle.openStream()));

			//strLine = br.readLine();
			//Read File Line By Line
			while (lineNumber >= 0){ 

				// Print the content on the console
				strLine = br.readLine(); 
				//System.out.println (strLine);
				if(!(strLine.equals(""))){
					if (Character.isLetter(strLine.charAt(0))){
						if(digitOrChar){ // if a character is looked for
							lineNumber = lineNumber - 1 ;
						}
					}
					else if (Character.isDigit(strLine.charAt(0))){
						if(!digitOrChar){ // if a digit is looked for 
							if (digitTime){
								if(strLine.contains(":")){
									lineNumber = lineNumber - 1 ;
								}
							}
							else {
								lineNumber = lineNumber - 1 ;
							}
						}

					}
				}

			}
			//Close the input stream
			// in.close();

		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		return strLine;
	}

	String compLine;
	String newLine;
	int compStartTime;
	int compStartTimeNext;
	Vector<String> outString = new Vector<String>();
	int[] lengthFinish =  new int[3]; 



	//public Vector<String> Readsrt(int startTime){
	public int[] Readsrt(int startTime){ 
		try{
			int[] startFinish;
			startFinish = new int[2];  
			int[] startFinishsrt;
			startFinishsrt = new int[2]; 
			int lengthStartTime;
			int lengthFinishTime;
			int lengthStartTimenext;
			// Open the file that is the first 
			// command line parameter
			//             FileInputStream fstream = new FileInputStream(srtFiles.get(counter));
			//             // Get the object of DataInputStream
			//             DataInputStream in = new DataInputStream(fstream);
			//             BufferedReader br = new BufferedReader(new InputStreamReader(in));
			URL oracle = new URL(MainFrame10.url_addr + "/" + srtFiles.get(counter));
			BufferedReader br = TextFile.getTextFile(oracle).getBufferedReader();//new BufferedReader(new InputStreamReader(oracle.openStream()));
			compStartTime = 0;
			outString.removeAllElements();

			while(compStartTime < startTime){

				compLine = br.readLine();
				if (compLine.contains("-->")){
					startFinish = IndexTime(compLine);
					compStartTime = startFinish[0];

				}
			}
			startFinishsrt = IndexTimesrt(compLine);
			lengthStartTime = startFinishsrt[0];
			lengthFinishTime = startFinishsrt[1];


			newLine = br.readLine();
			while(!((newLine.equals("") || newLine == null))){
				outString.add(newLine);
				newLine = br.readLine();
			}
			newLine = br.readLine();
			while(!(newLine.contains("-->"))){
				newLine = br.readLine();
			}

			startFinish = IndexTime(newLine);
			compStartTimeNext = startFinish[0];

			startFinishsrt = IndexTimesrt(newLine);
			lengthStartTimenext = startFinishsrt[0];

			int length2 = (((lengthStartTimenext / 100000)*60)*1000 + (lengthStartTimenext % 100000) ) - (((lengthStartTime / 100000)*60)*1000 + (lengthStartTime % 100000) );
			int length_end = (((lengthFinishTime / 100000)*60)*1000 + (lengthFinishTime % 100000) ) - (((lengthStartTime / 100000)*60)*1000 + (lengthStartTime % 100000) );

			lengthFinish[0] = length2;
			lengthFinish[1] = compStartTimeNext; 
			lengthFinish[2] = length_end;
			//Close the input stream
			//  in.close();



		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		return lengthFinish;
	}

	public int[] ReadTimes(boolean digitOrChar, boolean digitTime ){
		int[] startFinish;
		startFinish = new int[2];  
		String t_l = srtTimes.elementAt(counter);
		startFinish = IndexTime(t_l);
		return startFinish;
	}

	public int[] IndexTime(String lineRead){
		int[] startFinish;
		startFinish = new int[2];  
		int beginIndex = lineRead.indexOf(":");
		String st1 = lineRead.substring(beginIndex-2, beginIndex);
		String st2 = lineRead.substring(beginIndex+1, beginIndex+3);
		String st3 = lineRead.substring(beginIndex+4, beginIndex+6);

		int endIndex = lineRead.lastIndexOf(":");
		String f1 = lineRead.substring(endIndex-5, endIndex-3);
		String f2 = lineRead.substring(endIndex-2, endIndex);
		String f3 = lineRead.substring(endIndex+1, endIndex+3);

		int startTime = Integer.parseInt(st1+st2+st3);
		int finishTime = Integer.parseInt(f1+f2+f3);

		startFinish[0] = startTime; 
		startFinish[1] = finishTime; 

		return startFinish;
	}

	public int[] IndexTimesrt(String lineRead){
		int[] startFinish;
		startFinish = new int[2];  
		int beginIndex = lineRead.indexOf(":");
		String st1 = lineRead.substring(beginIndex-2, beginIndex);
		String st2 = lineRead.substring(beginIndex+1, beginIndex+3);
		String st3 = lineRead.substring(beginIndex+4, beginIndex+6);
		String st4 = lineRead.substring(beginIndex+7, beginIndex+10 );

		int endIndex = lineRead.lastIndexOf(":");
		String f1 = lineRead.substring(endIndex-5, endIndex-3);
		String f2 = lineRead.substring(endIndex-2, endIndex);
		String f3 = lineRead.substring(endIndex+1, endIndex+3);
		String f4 = lineRead.substring(endIndex+4, endIndex+7);

		int startTime = Integer.parseInt(st1+st2+st3+st4);
		int finishTime = Integer.parseInt(f1+f2+f3+f4);

		startFinish[0] = startTime; 
		startFinish[1] = finishTime; 

		return startFinish;
	}

	public void SrtReady(){

		lengthAll.removeAllElements();
		startAll.removeAllElements();
		sizeAll.removeAllElements();
		outStringAll.removeAllElements();

		// Reading start-finish times of srtTimes
		int[] sf = ReadTimes(false,true);
		start=sf[0];
		finish=sf[1];

		// Reading corresponding srt file 
		lengthFinish = Readsrt(start);
		lengthAll.add(lengthFinish[0]);
		startAll.add(lengthFinish[1]);
		sizeAll.add(outString.size());
		for(int i =0; i < outString.size(); i++){
			outStringAll.add(outString.get(i));
		}

		int i = 0;
		while(startAll.get(i) < finish ){
			i++;
			lengthFinish = Readsrt(startAll.get(i-1));
			lengthAll.add(lengthFinish[0] + lengthAll.get(i-1));
			//System.out.print(lengthFinish[0]);
			startAll.add(lengthFinish[1]);
			sizeAll.add(outString.size());
			for(int j =0; j < outString.size(); j++){
				outStringAll.add(outString.get(j));
			}

		}
		if (i==0){
			lengthAll.remove(lengthAll.indexOf((lengthAll.lastElement())));
			lengthAll.add(lengthFinish[2]);
		}
		else{
			lengthAll.remove(lengthAll.indexOf((lengthAll.lastElement())));
			lengthAll.add(lengthFinish[2] + lengthAll.get(i-1));
		}
		//lengthAll.add((int) (lengthAudio*1000 + timeToWait));
	}

	public void WritePane(String toBeWritten){
		try{
			//srtPane.removeAll();
			StyledDocument doc = srtPane.getStyledDocument();
			doc.remove(0, doc.getLength());
			// javax.swing.text.Style style = doc.addStyle("StyleName", null);
			//StyledDocument doc=new DefaultStyledDocument();
			SimpleAttributeSet attrb= new SimpleAttributeSet();  
			StyleConstants.setBold(attrb, true);
			StyleConstants.setFontFamily(attrb, "Arial");
			StyleConstants.setFontSize(attrb, 30);
			StyleConstants.setAlignment(attrb, StyleConstants.ALIGN_CENTER);
			StyleConstants.setBackground(attrb, Color.black);
			StyleConstants.setForeground(attrb, Color.white);
			srtPane.setCharacterAttributes(attrb, true);
			doc.setParagraphAttributes(0, doc.getLength(), attrb, false);
			doc.insertString(0, toBeWritten, attrb);
			srtPane.setDocument(doc);


		} catch (BadLocationException e) {
		}
	}

	public void JobOfStart(){
		startButton.setEnabled(false);
		playAgainButton.setEnabled(false);

		// Playing the sound file
		if (typeExp == 1 || typeExp == 2){
			clip.waitUntilReady();
		}
		//double length = clip.getLength();


		// Making Srt Ready

		SrtReady();


		if (typeExp == 0 || typeExp == 2){
			// Printing the first srt line
			for (int l=0; l < sizeAll.get(0); l++ ){
				toBeWritten = toBeWritten + outStringAll.get(0) + "\n";
				outStringAll.remove(0);
			}

			WritePane(toBeWritten);
			clipStartTime = CurrentTime();
			toBeWritten = " ";
		}
		if (typeExp == 1 || typeExp == 2){
			clip.play();
		}

		for (int k=1; k <= lengthAll.size(); k++){
			final int m=k;

			uctimer.schedule(new TimerTask() {
				FormDialogSubtitles Owner = FormDialogSubtitles.this;
				@Override
				public void run() {
					if (typeExp == 0 || typeExp == 2){
						if (m < lengthAll.size()){
							for (int l=0; l < sizeAll.get(m); l++ ){
								toBeWritten = toBeWritten + outStringAll.get(0) + "\n";
								outStringAll.remove(0);
							}

							WritePane(toBeWritten);
							toBeWritten = " ";
						}
					}

					if(m == lengthAll.size() ){	
						
						clipEndTime = CurrentTime();
						
						boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", sounds.elementAt(counter)+" ClipStarts "+clipStartTime+" ClipEnds "+clipEndTime+" ");
						if(!success){
							MainFrame10.WriteSuccessError();
						}
						
						counter++;

						//nextButton.setEnabled(true);
						for(JToggleButton buttonV: togglesV) {
							buttonV.setEnabled(true);
						}
						for(JToggleButton buttonA: togglesA) {
							buttonA.setEnabled(true);
						}


						nextButton.setEnabled(false);
						playAgainButton.setEnabled(true);

						if(counter != sounds.size()){
							try {
								clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
							} catch (MalformedURLException e1) {
								e1.printStackTrace();
							}
						}

						if (typeExp == 1 || typeExp == 2){
							nextButton.setResource(clip);
						}


					}
				}
			}, (long)(lengthAll.get(k-1)));



		}
	}

	public void JobOfNextWoWrite(){

		playAgainButton.setEnabled(false);
		nextButton.setEnabled(false);
		previousButton.setEnabled(false);
		for(JToggleButton buttonV: togglesV) {
			buttonV.setEnabled(false);
		}
		for(JToggleButton buttonA: togglesA) {
			buttonA.setEnabled(false);
		}

		// Playing the sound file

		if (typeExp == 1 || typeExp == 2){
			clip.waitUntilReady();
		}
		//double length = clip.getLength();

		// Making Srt Ready

		SrtReady();



		if (typeExp == 0 || typeExp == 2){	    	
			// Printing the first srt line
			for (int l=0; l < sizeAll.get(0); l++ ){
				toBeWritten = toBeWritten + outStringAll.get(0) + "\n";
				outStringAll.remove(0);
			}


			WritePane(toBeWritten);
			clipStartTime = CurrentTime();
			toBeWritten = " ";

		}
		if (typeExp == 1 || typeExp == 2){
			clip.play();
		}

		for (int k=1; k <= lengthAll.size(); k++){
			final int m=k;

			uctimer.schedule(new TimerTask() {
				@Override
				public void run() {
					if (typeExp == 0 || typeExp == 2){
						if (m < lengthAll.size()){
							for (int l=0; l < sizeAll.get(m); l++ ){
								toBeWritten = toBeWritten + outStringAll.get(0) + "\n";
								outStringAll.remove(0);
							}

							WritePane(toBeWritten);
							toBeWritten = " ";
						}
					}

					if(m == lengthAll.size() ){	
						
						clipEndTime = CurrentTime();
						
						boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_timelog.dat", sounds.elementAt(counter)+" ClipStarts "+clipStartTime+" ClipEnds "+clipEndTime+" ");
						if(!success){
							MainFrame10.WriteSuccessError();
						}
						counter++;

						//nextButton.setEnabled(true);
						for(JToggleButton buttonV: togglesV) {
							buttonV.setEnabled(true);
						}
						for(JToggleButton buttonA: togglesA) {
							buttonA.setEnabled(true);
						}

						nextButton.setEnabled(false);
						playAgainButton.setEnabled(true);

						if(counter >= 2 ){ 
							previousButton.setEnabled(true);
						}

						if(counter != sounds.size()){
							try {
								clip = Clip.getClip(new URL(MainFrame10.url_addr+"/"+sounds.elementAt(counter)));
							} catch (MalformedURLException e1) {
								e1.printStackTrace();
						}
						}

						if (typeExp == 1 || typeExp == 2){
							nextButton.setResource(clip);
						}

					}
				}
			}, (long)(lengthAll.get(k-1)));




		}
	}

	public void WriteRatings(){
		try {
			String ratingsToWrite = sounds.elementAt(counter-1) + " " + "Valence" + " ";
			for(int i=0; i<9; i++) {
				//boolean to String conversion
				String theValueAsString = new Integer(togglesV.get(i).isSelected() ? 1:0).toString();
				ratingsToWrite = ratingsToWrite + theValueAsString+" ";
				togglesV.get(i).setSelected(false);
				togglesV.get(i).setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
			}
			ratingsToWrite = ratingsToWrite + "Arousal" + " ";
			for(int i=0; i<9; i++) {		        
				//boolean to String conversion
				String theValueAsString = new Integer(togglesA.get(i).isSelected() ? 1:0).toString();
				ratingsToWrite = ratingsToWrite + theValueAsString+" ";
				togglesA.get(i).setSelected(false);
				togglesA.get(i).setBorder(BorderFactory.createLineBorder(new Color(184, 207, 229), 4));
			}
			ratingsToWrite = ratingsToWrite + lineEnd;
			boolean success=Writer.write(MainFrame10.url_addr+"/cgi-bin/", attendantNameString, fileName+"_ratings.dat", ratingsToWrite);
			if(!success){
				MainFrame10.WriteSuccessError();
			}

		} 			catch (Exception ex)
		{
			System.err.println ("Error writing to file");
		}
	}

	public String CurrentTime(){

		Calendar calendar = new GregorianCalendar();
		String am_pm;

		int hour = calendar.get(Calendar.HOUR_OF_DAY);
		int minute = calendar.get(Calendar.MINUTE);
		int second = calendar.get(Calendar.SECOND);
		String hourStr;
		String minStr;
		String secStr;
		if(hour<10){
			hourStr = Integer.toString(0)  + Integer.toString(hour);
		} 
		else{
			hourStr =  Integer.toString(hour);
		}
		if(minute<10){
			minStr = Integer.toString(0)  + Integer.toString(minute);
		} 
		else{
			minStr =  Integer.toString(minute);
		}
		if(second<10){
			secStr = Integer.toString(0)  + Integer.toString(second);
		} 
		else{
			secStr =  Integer.toString(second);
		}
		String time_out = hourStr+minStr+secStr;
		return time_out;
	}


}


