package gui;


import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

import javax.lang.model.type.PrimitiveType;


public class Writer {
	public static boolean write(String scriptBase, String userName, String fileName, String data) {
	    Map<String, String> pairs = new HashMap<String, String>();
		pairs.put("User", userName);
		pairs.put("File", fileName);
		pairs.put("Data", data);
		return sendPairs(scriptBase, pairs);
	}
	public static boolean clearUser(String scriptBase,String userName) {
	    Map<String, String> pairs = new HashMap<String, String>();
		pairs.put("User", userName);
	    pairs.put("Clear", "true"); 
		return sendPairs(scriptBase, pairs);
	}
	public static boolean clearFile(String scriptBase,String userName, String fileName) {
	    Map<String, String> pairs = new HashMap<String, String>();
		pairs.put("User", userName);
		pairs.put("File", fileName);
	    pairs.put("Clear", "true"); 
		return sendPairs(scriptBase, pairs);		
	}

	private static boolean sendPairs(String scriptBase, Map<String,String> pairs) {
		try{
			
			String message = "";
			Object keys[] = pairs.keySet().toArray();
			message+= keys[0] + "=" + URLEncoder.encode(pairs.get(keys[0]),"US-ASCII"); 
			for(int i=1; i<pairs.size(); i++) {
				message+= "&" + keys[i] + "=" + URLEncoder.encode(pairs.get(keys[i]),"US-ASCII"); 
			}
		    URL                url; 
		    URLConnection      urlConn; 
		    DataOutputStream   dos; 
		    BufferedReader    dis;
		    
		    String lineEnd = "\r\n";


		    //url = new URL("http://"+scriptBase+"record.pl"); 
		    url = new URL(scriptBase+"record.pl"); 
		    urlConn = url.openConnection(); 
		    urlConn.setDoInput(true); 
		    urlConn.setDoOutput(true); 
		    urlConn.setUseCaches(false); 
		    urlConn.setRequestProperty ("Content-Type", "application/x-www-form-urlencoded");

		    dos = new DataOutputStream (urlConn.getOutputStream()); 
		    dos.writeBytes(message); 
		    dos.flush(); 
		    dos.close(); 	    
		    dis = new BufferedReader(new InputStreamReader(urlConn.getInputStream())); 
		    String reply = dis.readLine();
		    dis.close(); 
		    if(reply.equals("success")) return true;

		}
		catch (MalformedURLException e) {
			System.out.println(e.getMessage());
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		return false;
	}
}
